package DevLog;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Vector;

public class SerializationDemo implements Serializable {

	int a;
	char c;
	Vector<Double> v;

	public SerializationDemo(int a, char c, double[] elements) {
		this.a = a;
		this.c = c;
		this.v = new Vector<Double>(elements.length);
		for (double ev : elements) {
			v.add(new Double(ev));
		}
	}

	private void writeObject(ObjectOutputStream out) throws IOException {
		out.defaultWriteObject();
		// ou le faire objet par objet :
		// out.writeInt(a);
		// out.writeChar(c);
		// out.writeObject(v);
	}

	private void readObject(ObjectInputStream in) throws IOException,
			ClassNotFoundException {
		in.defaultReadObject();
		// ou le faire par objet
		// in.readInt(a);
		// in.readChar(c);
		// in.readObject(v);

	}

	public boolean equal(SerializationDemo sd) {
		if (a != sd.a || c != sd.c || v.size() != sd.v.size())
			return false;

		for (int i = 0; i < v.size(); ++i)
			if (v.elementAt(i).doubleValue() != sd.v.elementAt(i).doubleValue())
				return false;

		return true;
	}

	public static void main(String[] args) {

		SerializationDemo test = new SerializationDemo(10, 'a', new double[] {
				5, .16, 7.3, 44.33 });
		SerializationDemo test1 = null;
		SerializationDemo test2 = null;

		try {
			ObjectOutputStream out1 = new ObjectOutputStream(
					new FileOutputStream("monFichier1.sav"));
			out1.writeObject(test);
			out1.close();
			ObjectOutputStream out2 = new ObjectOutputStream(
					new FileOutputStream("monFichier2.sav"));
			out2.writeObject(test);
			out2.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			ObjectInputStream in1 = new ObjectInputStream(new FileInputStream(
					"monFichier1.sav"));
			test1 = (SerializationDemo) (in1.readObject());
			in1.close();
			ObjectInputStream in2 = new ObjectInputStream(new FileInputStream(
					"monFichier2.sav"));
			test2 = (SerializationDemo) (in1.readObject());
			in1.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

		assert (!test1.equals(test2)) : "Problme avec la serialization !";

	}
}
